package com.eu.habbo.habbohotel.commands;

import com.eu.habbo.Emulator;
import com.eu.habbo.habbohotel.gameclients.GameClient;

public class WordQuizCommand extends Command {
    public WordQuizCommand() {
        super("cmd_word_quiz", Emulator.getTexts().getValue("commands.keys.cmd_word_quiz").split(";"));
    }

    @Override
    public boolean handle(GameClient gameClient, String[] params) throws Exception {
        if (!gameClient.getHabbo().getHabboInfo().getCurrentRoom().hasActiveWordQuiz()) {
            StringBuilder question = new StringBuilder();
            int duration = 60;

            if (params.length > 2) {
                for (int i = 1; i < params.length - 1; i++) {
                    question.append(" ").append(params[i]);
                }

                try {
                    duration = Integer.valueOf(params[params.length - 1]);
                } catch (Exception e) {
                    question.append(" ").append(params[params.length - 1]);
                }
            } else {
                question = new StringBuilder(params[1]);
            }

            gameClient.getHabbo().getHabboInfo().getCurrentRoom().startWordQuiz(question.toString(), duration * 1000);
        }
        return true;
    }
}